var _G = {};
var _APPID = 'logView';
var _LOG_PARAM = [];

function curry(func, args, space) {
    var n  = func.length - args.length; //arguments still to come
    var sa = Array.prototype.slice.apply(args); // saved accumulator array
    function accumulator(moreArgs,sa,n) {
        var saPrev = sa.slice(0); // to reset
        var nPrev  = n; // to reset
        for(var i=0;i<moreArgs.length;i++,n--) {
            sa[sa.length] = moreArgs[i];
        }
        if ((n-moreArgs.length)<=0) {
            var res = func.apply(space,sa);
            // reset vars, so curried function can be applied to new params.
            sa = saPrev;
            n  = nPrev;
            return res;
        } else {
            return function (){
                // arguments are params, so closure bussiness is avoided.
                return accumulator(arguments,sa.slice(0),n);
            }
        }
    }
    return accumulator([],sa,n);
}

function replyFromNativeMethod( arg ) {
    // 12.27  ========== uncomment below and check arg !!!!
    var r = arg.split('@@');

    if(_G[r[0]] != null) {
        _G[r[0]](r[1]);
    }else {
        alert('callback not found');
    }
}


//function add (a,b,c){ 
//    if (arguments.length < this.add.length) {
//        return curry(this.add,arguments,this);
//    }  
//    return a+b+c;
//}


function uniqid()
{    
    var newDate = new Date;
    return 'UID_' + newDate.getTime();
}


function callNativeMethod( arg ) {
    var uid = uniqid();
    var p = [];
    
    p[0] = _APPID;
    p[1] = arg.methodName;
    p[2] = arg.param.join('@@');
    
    if(arg.callback != null) {
        p[3] = uid
        
        _G[uid] = function( ocArg) {
            var result = ocArg.split('::');
			if(result.length==3)
				arg.callback(result[0],result[1],result[2]);
			else
				arg.callback(result[0],result[1]);
            _G[uid] = null;
        }
    }
    //alert( arg.methodName );
    document.location = p.join('::');
}


function makeKeyStr(p1,p2,p3,p4,op5) {
    if(op5 != null) {
        switch(op5) {
            case 'SYSTEM':
            case 'EVENT':
            return p1;
            break;
                
            case 'LOG ON/OFF':
            case 'SETUP CHANGE':
            case 'RECORD':
            case 'VCA':
            return p1 + '_' + p3;
            break;
        }
    }else {
        var p1Val = parseInt(p1);
        if( p1Val <= 7 ) {
            return p1;
        }else if(  8 <= p1Val &&  p1Val <= 13 ) {
            return p1 + '_' + p3;
        }else if( 14 <= p1Val &&  p1Val <= 22 ) {
            return p1;
        }else if( 23 <= p1Val ) {
            return p1 + '_' + p3;
        }else if( 30 <= p1Val ) {
          return p1 + '_' + p3;
        }
    }
}

function _LogParam( p ) {
    var x = {
        category : p[0],
        msg : p[5]
    };
    
    _LOG_PARAM[ makeKeyStr(p[1], p[2], p[3], p[4], p[0]) ] = x;
}


function boolConv( v, legend ) {
	
	if( v == '1') {
		return legend[0];
	}else if(v == '0') {
		return legend[1];
	}else {
		return v;
	}
}

function getLogMsgx( log ) {
	var lp = log.split('.');

	var v1 = lp.shift();
	//var v2 = "" + eval( lp.shift() + " + 1") ;
	var v2 = lp.shift();
	var v3 = lp.shift();
	var v4 = lp.join('.');
	
	var msg = _LOG_PARAM[ makeKeyStr(v1, v2, v3, v4) ].msg;

	//msg.replace('<who>' , v4);
	msg = msg.split('<who>').join(v4);
	msg = msg.split('<#channel>').join(v2);
	
	//msg = msg.split('<on/off>').join( boolConv(v3,['ON','OFF']) );
	//msg = msg.split('<in/loss>').join( boolConv(v3,['IN','LOSS']) );
	//msg = msg.split('<internal/external>').join( boolConv(v3,['INTERNAL','EXTERNAL']) );
}

function getLogMsg( log ) {
    var lp = log.split('.');
    
    var v1 = lp.shift();
    var v2 = lp.shift();
	try {
		v2 = "" + eval( v2 + " + 1") ;
	}catch(e) {}
	
    var v3 = lp.shift();
    var v4 = lp.join('.');
    
    var msg = _LOG_PARAM[ makeKeyStr(v1, v2, v3, v4) ].msg;
    
    //msg.replace('<who>' , v4);
    msg = msg.split('<who>').join(v4);
    msg = msg.split('<#channel>').join(v2);
    
    msg = msg.split('<on/off>').join(boolConv(v3,['ON','OFF']) );
    msg = msg.split('<in/loss>').join(boolConv(v3,['IN','LOSS']));
    msg = msg.split('<internal/external>').join(boolConv(v3,['INTERNAL','EXTERNAL']));
  
    msg = msg.split('<vaevent>').join(vaConv(v4));
  
    return msg;
}


function vaConv(msg) {
  var rMsg;
  msg = parseInt(msg);
  switch(msg){
    case 0x00000001:
      rMsg = "VCA Positive direction";
      break;
    case 0x00000002:
      rMsg = "VCA Negative direction";
      break;
    case 0x00000010:
      rMsg = "VCA Enter";
      break;
    case 0x00000020:
      rMsg = "VCA Exit";
      break;
    case 0x00000040:
      rMsg = "VCA Stopped";
      break;
    case 0x00000080:
      rMsg = "VCA Abandoned";
      break;
    case 0x00000100:
      rMsg = "VCA Removed Removed";
      break;
    case 0x00000200:
      rMsg = "VCA Loitering";
      break;
    case 0x00000400:
      rMsg = "VCA Fall";
      break;
    case 0x00004000:
      rMsg = "VCA Counter";
      break;
    case 0x00008000:
      rMsg = "VCA Camera tamper";
      break;
    case 0x00010000:
      rMsg = "VCA etc";
      break;
    case 0x00020000:
      rMsg = "VCA etc";
      break;
    case 0x00040000:
      rMsg = "VCA etc";
      break;
    case 0x00080000:
      rMsg = "VCA etc";
      break;
    default :
      rMsg = "VCA etc";
      break;
  }
  return rMsg;
}

function getChn(log) {
    var lp = log.split('.');
    
    var v1 = lp.shift();
    var v2 = lp.shift();
    var v3 = lp.shift();
    var v4 = lp.join('.');
    
    var msg = _LOG_PARAM[ makeKeyStr(v1, v2, v3, v4) ].msg;
	
	try {
		v2 = "" + eval( v2 + " + 1") ;
	}catch(e) {}
    
    if( msg.indexOf('<#channel>') >=0 ) {
        return v2;
    }else {
        return '';
    }
}

_LogParam(['SYSTEM','0','none','none','none','SYSTEM STARTED']);
_LogParam(['SYSTEM','1','none','none','none','SYSTEM SHUTDOWN']);
_LogParam(['SYSTEM','2','none','none','none','ABNORMAL SHUTDOWN DETECTED']);
_LogParam(['SYSTEM','3','none','none','none','SYSTEM RECOVERED']);
_LogParam(['SYSTEM','4','num of string','none','who','SYSTEM DATE&TIME CHANGED : <who>']);
_LogParam(['SYSTEM','5','num of string','none','who','FIRMWARE UPGRADE START : <who>']);
_LogParam(['SYSTEM','6','num of string','none','who','FORMAT DISKS : <who>']);
_LogParam(['SYSTEM','7','num of string','none','who','CHECK DISK : <who>']);
_LogParam(['LOG ON/OFF','8','num of string','0','who','LOCAL LOG ON : LIVE DISPLAY : <who>']);
_LogParam(['LOG ON/OFF','8','num of string','1','who','LOCAL LOG ON : SEARCH : <who>']);
_LogParam(['LOG ON/OFF','8','num of string','2','who','LOCAL LOG ON : ARCHIVING : <who>']);
_LogParam(['LOG ON/OFF','8','num of string','3','who','LOCAL LOG ON : SYSTEM SETUP : <who>']);
_LogParam(['LOG ON/OFF','8','num of string','4','who','LOCAL LOG ON : RECORD SETUP : <who>']);
_LogParam(['LOG ON/OFF','9','num of string','0','who','LOCAL LOG OFF : LIVE DISPLAY : <who>']);
_LogParam(['LOG ON/OFF','9','num of string','1','who','LOCAL LOG OFF : SEARCH : <who>']);
_LogParam(['LOG ON/OFF','9','num of string','2','who','LOCAL LOG OFF : ARCHIVING : <who>']);
_LogParam(['LOG ON/OFF','9','num of string','3','who','LOCAL LOG OFF : SYSTEM SETUP : <who>']);
_LogParam(['LOG ON/OFF','9','num of string','4','who','LOCAL LOG OFF : RECORD SETUP : <who>']);
_LogParam(['LOG ON/OFF','10','num of string','0','who','REMOTE LOG ON : LIVE DISPLAY : <who>']);
_LogParam(['LOG ON/OFF','10','num of string','1','who','REMOTE LOG ON : SEARCH : <who>']);
_LogParam(['LOG ON/OFF','10','num of string','2','who','REMOTE LOG ON : ARCHIVING : <who>']);
_LogParam(['LOG ON/OFF','10','num of string','3','who','REMOTE LOG ON : SYSTEM SETUP : <who>']);
_LogParam(['LOG ON/OFF','10','num of string','4','who','REMOTE LOG ON : RECORD SETUP : <who>']);
_LogParam(['LOG ON/OFF','11','num of string','0','who','REMOTE LOG OFF : LIVE DISPLAY : <who>']);
_LogParam(['LOG ON/OFF','11','num of string','1','who','REMOTE LOG OFF : SEARCH : <who>']);
_LogParam(['LOG ON/OFF','11','num of string','2','who','REMOTE LOG OFF : ARCHIVING : <who>']);
_LogParam(['LOG ON/OFF','11','num of string','3','who','REMOTE LOG OFF : SYSTEM SETUP : <who>']);
_LogParam(['LOG ON/OFF','11','num of string','4','who','REMOTE LOG OFF : RECORD SETUP : <who>']);
_LogParam(['SETUP CHANGE','12','num of string','0','who','RECORD SETUP CHANGED : RECORD MODE : <who>']);
_LogParam(['SETUP CHANGE','12','num of string','7','who','RECORD SETUP CHANGED : PANIC RECORD PARAMETER : <who>']);
_LogParam(['SETUP CHANGE','12','num of string','16','who','RECORD SETUP CHANGED : ALARM RECORD PARAMETER : <who>']);
_LogParam(['SETUP CHANGE','12','num of string','17','who','RECORD SETUP CHANGED : ALARM RECORD SCHEDULE : <who>']);
_LogParam(['SETUP CHANGE','12','num of string','18','who','RECORD SETUP CHANGED : CONTINUOUS/MOTION RECORD PARAMETER : <who>']);
_LogParam(['SETUP CHANGE','12','num of string','19','who','RECORD SETUP CHANGED : CONTINUOUS/MOTION RECORD SCHEDULE : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','0','who','SYSTEM SETUP CHANGED : CAMERA TITLE : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','1','who','SYSTEM SETUP CHANGED : CAMERA COLOR  : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','2','who','SYSTEM SETUP CHANGED : CAMERA PTZ : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','3','who','SYSTEM SETUP CHANGED : CAMERA OSD : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','4','who','SYSTEM SETUP CHANGED : SENSOR EVENT : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','7','who','SYSTEM SETUP CHANGED : STORAGE EVENT : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','9','who','SYSTEM SETUP CHANGED : EVENT ACTION ALRAM OUT : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','10','who','SYSTEM SETUP CHANGED : EVENT ACTION E-MAIL NOTIFICATION : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','13','who','SYSTEM SETUP CHANGED : EVENT ACTION BUZZER : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','15','who','SYSTEM SETUP CHANGED : DISLAY MAIN DISPLAY : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','16','who','SYSTEM SETUP CHANGED : DISPLAY SPOT1# : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','17','who','SYSTEM SETUP CHANGED : DISPLAY SPOT2# : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','18','who','SYSTEM SETUP CHANGED : DISPLAY SPOT3# : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','19','who','SYSTEM SETUP CHANGED : DISPLAY SPOT4# : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','20','who','SYSTEM SETUP CHANGED : AUDIO : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','21','who','SYSTEM SETUP CHANGED : USER ID : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','22','who','SYSTEM SETUP CHANGED : USER GROUP : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','24','who','SYSTEM SETUP CHANGED : NETWORK EMAIL : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','25','who','SYSTEM SETUP CHANGED : SYSTEM GERNERAL INFOMAION : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','26','who','SYSTEM SETUP CHANGED : SYSTEM DATE&TIME : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','27','who','SYSTEM SETUP CHANGED : STORAGE OPRATION : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','28','who','SYSTEM SETUP CHANGED : CAMERA COVERT : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','29','who','SYSTEM SETUP CHANGED : CAMERA MOTION SENSOR : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','32','who','SYSTEM SETUP CHANGED : CAMERA AUDIO MAPPING : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','33','who','SYSTEM SETUP CHANGED : DISPLAY OSD : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','34','who','SYSTEM SETUP CHANGED : DISPLAY MONITOR : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','35','who','SYSTEM SETUP CHANGED : AUDIO BUZZER : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','36','who','SYSTEM SETUP CHANGED : CONTROL DEVICE : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','37','who','SYSTEM SETUP CHANGED : AUTO LOGOUT : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','38','who','SYSTEM SETUP CHANGED : NETWORK IP : <who>']);
_LogParam(['SETUP CHANGE','13','num of string','39','who','SYSTEM SETUP CHANGED : NETWORK DDNS : <who>']);
_LogParam(['EVENT','14','#channel','on/off','none','SENSOR <#channel> : <on/off>']);
_LogParam(['EVENT','15','#channel','on/off','none','MOTION DETECTION <#channel> : <on/off>']);
_LogParam(['EVENT','17','#channel','in/loss','none','VIDEO <in/loss> : <#channel>']);
_LogParam(['EVENT','19','none','internal/external','none','S.M.A.R.T. WARNING : <internal/external> STORAGE']);
_LogParam(['EVENT','20','none','internal/external','none','HDD OVER TEMPERATURE : <internal/external> STORAGE']);
_LogParam(['EVENT','21','none','internal/external','none','DISK FULL : <internal/external> STORAGE']);
_LogParam(['EVENT','22','none','internal/external','none','OVERWRITE START : <internal/external> STORAGE']);
_LogParam(['RECORD','23','#channel','0','none','CONTINUOUS RECORDING ON : <#channel>']);
_LogParam(['RECORD','23','#channel','1','none','ALARM RECORDING ON : <#channel>']);
_LogParam(['RECORD','23','#channel','2','none','MOTION RECORDING ON : <#channel>']);
_LogParam(['RECORD','23','#channel','3','none','U.EVT. RECORDING ON : <#channel>']);
_LogParam(['RECORD','23','#channel','4','none','PANIC RECORDING ON : <#channel>']);
_LogParam(['RECORD','24','#channel','0','none','CONTINUOUS RECORDING OFF : <#channel>']);
_LogParam(['RECORD','24','#channel','1','none','ALARM RECORDING OFF : <#channel>']);
_LogParam(['RECORD','24','#channel','2','none','MOTION RECORDING OFF : <#channel>']);
_LogParam(['RECORD','24','#channel','3','none','U.EVT. RECORDING OFF : <#channel>']);
_LogParam(['RECORD','24','#channel','4','none','PANIC RECORDING OFF : <#channel>']);

_LogParam(['VCA','30','#channel','0','vaevent','VCA : A VCA event on camera #<#channel> : <vaevent>']);


//alert( getLogMsg( '19.none.internal.none'));
//alert( getLogMsg( '14.5.on.none'));



/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
    timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
    timezoneClip = /[^-+\dA-Z]/g,
    pad = function (val, len) {
    val = String(val);
    len = len || 2;
    while (val.length < len) val = "0" + val;
    return val;
    };
    
	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
    var dF = dateFormat;
    
    // You can't provide utc if you skip other args (use the "UTC:" mask prefix)
    if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
    mask = date;
    date = undefined;
    }
    
    // Passing date through Date applies Date.parse, if necessary
    date = date ? new Date(date) : new Date;
    if (isNaN(date)) throw SyntaxError("invalid date");
    
    mask = String(dF.masks[mask] || mask || dF.masks["default"]);
    
    // Allow setting the utc argument via the mask
    if (mask.slice(0, 4) == "UTC:") {
    mask = mask.slice(4);
    utc = true;
    }
    
    var	_ = utc ? "getUTC" : "get",
    d = date[_ + "Date"](),
    D = date[_ + "Day"](),
    m = date[_ + "Month"](),
    y = date[_ + "FullYear"](),
    H = date[_ + "Hours"](),
    M = date[_ + "Minutes"](),
    s = date[_ + "Seconds"](),
    L = date[_ + "Milliseconds"](),
    o = utc ? 0 : date.getTimezoneOffset(),
    flags = {
    d:    d,
    dd:   pad(d),
    ddd:  dF.i18n.dayNames[D],
    dddd: dF.i18n.dayNames[D + 7],
    m:    m + 1,
    mm:   pad(m + 1),
    mmm:  dF.i18n.monthNames[m],
    mmmm: dF.i18n.monthNames[m + 12],
    yy:   String(y).slice(2),
    yyyy: y,
    h:    H % 12 || 12,
    hh:   pad(H % 12 || 12),
    H:    H,
    HH:   pad(H),
    M:    M,
    MM:   pad(M),
    s:    s,
    ss:   pad(s),
    l:    pad(L, 3),
    L:    pad(L > 99 ? Math.round(L / 10) : L),
    t:    H < 12 ? "a"  : "p",
    tt:   H < 12 ? "am" : "pm",
    T:    H < 12 ? "A"  : "P",
    TT:   H < 12 ? "AM" : "PM",
    Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
    o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
    S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
    };
    
    return mask.replace(token, function ($0) {
    return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
    });
	};
    }();
    
    // Some common format strings
    dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
    };
    
    // Internationalization strings
    dateFormat.i18n = {
	dayNames: [
    "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
    "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
    "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
    "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
    };
    
    // For convenience...
    Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
    };
    
                 